/*************************************************************************
 *
 *    Used with ICCARM and AARM.
 *
 *    (c) Copyright IAR Systems 2007
 *
 *    File name   : main.c
 *    Description : CAN test
 *
 *    History :
 *    1. Date        : April 28, 2007
 *       Author      : Stanimir Bonev
 *       Description : Create
 *
 *    $Revision: 1.4 $
 **************************************************************************/
// #include <stdio.h>

#include <stdio.h>
#include <stdlib.h>

#include "stm32f10x_lib.h"
#include "arm_comm.h"
#include "lcd.h"
#include "stm32f10x_map.h"
#include "bits.h"
#include "adc.h"
#include "nRF24L01.h"
#include "const.h"
#include "drv_lisxxx.h"

#define KEY_NONE    0
#define KEY_UP      1
#define KEY_DOWN    2
#define KEY_LEFT    3
#define KEY_RIGHT   4
#define KEY_CENTER  5

#define UP_VALUE        960
#define DOWN_VALUE      190
#define LEFT_VALUE     1990
#define RIGHT_VALUE     470
#define DIVERSION        30

__root __no_init volatile RCC_TypeDef     ttt1 @ RCC_BASE;
__root __no_init volatile GPIO_TypeDef    ttt2 @ GPIOB_BASE;
__root __no_init volatile AFIO_TypeDef    ttt3 @ AFIO_BASE;
__root __no_init volatile I2C_TypeDef     ttt4 @ I2C1_BASE;


unsigned char ch=0, index=0, but2_flag=0;
unsigned char config, status_temp, payload;
extern unsigned char status;
extern GPIO_InitTypeDef GPIO_InitStructure;
volatile unsigned int dly;
Int16U ADCValue;
unsigned char jjj=0;

unsigned char JoyPos;
//unsigned char MenuPos;
unsigned char buf;


unsigned char ch;
unsigned char b=0;
unsigned int i = 0;
unsigned char config, dummy, var, payload;

/////////////////////////////////////////////////////////////////
void Delay_ (unsigned long a) { while (--a!=0); }


/*************************************************************************
 * Function Name: Clk_Init
 * Parameters: Int32U Frequency
 * Return: Int32U
 *
 * Description: Init clock system
 *
 *************************************************************************/
void Clk_Init(void)
{
  // 1. Cloking the controller from internal HSI RC (8 MHz)
  RCC_HSICmd(ENABLE);
  // wait until the HSI is ready
  while(RCC_GetFlagStatus(RCC_FLAG_HSIRDY) == RESET);
  RCC_SYSCLKConfig(RCC_SYSCLKSource_HSI);
  // 2. Enable ext. high frequency OSC
  RCC_HSEConfig(RCC_HSE_ON);
  // wait until the HSE is ready
  while(RCC_GetFlagStatus(RCC_FLAG_HSERDY) == RESET);
  // 3. Init PLL
  RCC_PLLConfig(RCC_PLLSource_HSE_Div1,RCC_PLLMul_9); // 72MHz
//  RCC_PLLConfig(RCC_PLLSource_HSE_Div2,RCC_PLLMul_9); // 72MHz
  RCC_PLLCmd(ENABLE);
  // wait until the PLL is ready
  while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);
  // 4. Set system clock divders
  RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_1Div5);
  RCC_ADCCLKConfig(RCC_PCLK2_Div8);
  RCC_PCLK2Config(RCC_HCLK_Div1);
  RCC_PCLK1Config(RCC_HCLK_Div2);
  RCC_HCLKConfig(RCC_SYSCLK_Div1);
  /* Flash 1 wait state */
  *(vu32 *)0x40022000 = 0x01;
  // 5. Clock system from PLL
  RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
}


/*************************************************************************
 * Function Name: InitJoystick
 * Parameters: none
 * Return: none
 *
 * Description: Init joystick position
 *
 *************************************************************************/
void InitJoystick(void) {

  // Set variables asociates
  JoyPos = 0;
  

  // Init
  ADCInit();

  // BUTTON CENTER as input
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

  // B1 as input
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_13;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);

}


/*************************************************************************
 * Function Name: GetJoystickPosition
 * Parameters: none
 * Return: Joistick position
 *
 * Description: Measure ADC and return joystick position
 *
 *************************************************************************/
unsigned char GetJoystickPosition (void) {

  ADCValue = GetADCChanel(ADC_Channel_15);

  if( (ADCValue>(UP_VALUE-DIVERSION))&&(ADCValue<(UP_VALUE+DIVERSION)) )       { return KEY_UP; }
  if( (ADCValue>(DOWN_VALUE-DIVERSION))&&(ADCValue<(DOWN_VALUE+DIVERSION)) )   { return KEY_DOWN; }
  if( (ADCValue>(LEFT_VALUE-DIVERSION))&&(ADCValue<(LEFT_VALUE+DIVERSION)) )   { return KEY_LEFT; }
  if( (ADCValue>(RIGHT_VALUE-DIVERSION))&&(ADCValue<(RIGHT_VALUE+DIVERSION)) ) { return KEY_RIGHT; }

  if((GPIO_ReadInputDataBit(GPIOC, GPIO_Pin_6)) == Bit_SET) return KEY_CENTER;

  return KEY_NONE;

}
/*************************************************************************
 * Function Name: main
 * Parameters: none
 * Return: Int32U
 *
 * Description: The main subroutine
 *
 *************************************************************************/
/*NOTE:
Act as an ECHO-server - reply byte , sent from the client
*/
int main(void)
{

  #ifdef DEBUG
    debug();
  #endif

  // Init clock system
  Clk_Init();

  // LCD init
  LCDInit();
  LCDContrast(0x45);

  LCDClear();
  LCDStr ( 0, "   Welcome to ", 0 );
  LCDStr ( 1, " STM32F103-STK", 0 );
  LCDStr ( 2, "  development ", 0 );
  LCDStr ( 3, "     board    ", 0 );
  LCDStr ( 5, "www.olimex.com", 1 );
  LCDUpdate();

  // Delay :-)
  for(dly=0; dly<5000000; dly++);

// Test NRF ------------------------------------------------------------------
  

    LCDClear();
    LCDStr ( 0, "  Echo server   ", 0 );
    LCDStr ( 1, "   for RF      ", 0 );
    LCDStr ( 2, "bidirectional ", 0 );
    LCDStr ( 3, "     link    ", 0 );
    LCDUpdate();

     //light STATUS LED
    GPIO_WriteBit(GPIOC, GPIO_Pin_10, Bit_SET);
    //RF setting
    nRFSetting();
   
  
    while(1){
      
                    
                    CE_LOW();
              
              //WRITE CONFIG_REG
                  status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0B);  //00001010 - CRC enable, power-up, RX
              //read CONFIG_REGG
                  config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
              //WRITE RX_ADDR_P0
                  status = SPI_Send_command_with_ADDR(W_REGISTER,RX_ADDR_P0, NOP);
              //READ RX_ADDR_P0
                  status = SPI_Send_command_with_ADDR(R_REGISTER,RX_ADDR_P0, NOP);
              
              //WRITE RX_ADDR_P1
                  status = SPI_Send_command_with_ADDR(W_REGISTER,RX_ADDR_P1, NOP);
              //READ RX_ADDR_P1
                  status = SPI_Send_command_with_ADDR(R_REGISTER,RX_ADDR_P1, NOP);
              
              //WRITE TX_ADDR
                  status = SPI_Send_command_with_ADDR(W_REGISTER,TX_ADDR, NOP);
              //READ TX_ADDR
                  status = SPI_Send_command_with_ADDR(R_REGISTER,TX_ADDR, NOP);
              
              //WRITE RX_PW_P0_REG
              status = SPI_Send_command_with_ADDR(W_REGISTER,RX_PW_P0, 1);   //1 byte payload
              //READ RX_PW_P0_REG
              dummy = SPI_Send_command_with_ADDR(R_REGISTER,RX_PW_P0, NOP);
              
              //WRITE RX_PW_P1_REG
              status = SPI_Send_command_with_ADDR(W_REGISTER,RX_PW_P1, 1);   //1 byte payload
              //READ RX_PW_P1_REG
              dummy = SPI_Send_command_with_ADDR(R_REGISTER,RX_PW_P1, NOP);
              
              //read FIFO_STATUS_REG
              dummy = SPI_Send_command_with_ADDR(R_REGISTER,FIFO_STATUS, NOP);
              
              //SEND payload
              //status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x45);
              
              //FLUSH_TX
              status = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);
              
              //read FIFO_STATUS_REG
              dummy = SPI_Send_command_with_ADDR(R_REGISTER,FIFO_STATUS, NOP);

              i=i;
              b=0;
            // loop forever
            while(1)
            {


                CE_HIGH();
                //read CONFIG_REGG
                config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
                //READ STATUS
                status = SPI_Send_command_without_ADDR(NOP, NOP);
                if ((IRQ)==0)
               {
                    CE_LOW();
                    //READ STATUS
                    status = SPI_Send_command_without_ADDR(NOP, NOP);
              
                    if ((status & RX_DR) != 0)
                    {
                      //read payload
                      payload=SPI_Send_command_without_ADDR(R_RX_PAYLOAD, NOP);
                      //restore RX_DR
                      var=status;
                      var |= RX_DR;
                      status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                     
                    }
              
                    if (payload == 0x01)
                    {
                      payload=0;
                                    
                      //WRITE CONFIG_REG
                      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0A);  //00001010 - CRC enable, power-up, TX
                      //read CONFIG_REGG
                      config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
                      Delay_(RX_TX_TIME);    //wait while the master go to RX mode
              
                      //Send payload
                      status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x01);
                      CE_HIGH();
                      CE_LOW();
                      //READ STATUS
                      status = SPI_Send_command_without_ADDR(NOP, NOP);
                      if ((status & MAX_RT) != 0)
                      {
                        var=status;
                        var |= MAX_RT;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                        }
                      if ((status & TX_DS) != 0)
                      {
                        var=status;
                        var |= TX_DS;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                         }
                      if ((status & TX_FULL) != 0)  //if TX full
                      {
                        status_temp = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);
                       }
                    }
                      
                      if (payload == 0x02)
                    {
                      payload=0;
                      
              
                      //WRITE CONFIG_REG
                      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0A);  //00001010 - CRC enable, power-up, TX
                      //read CONFIG_REGG
                      config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
                      Delay_(RX_TX_TIME);    //wait while the master go to RX mode
              
                      //Send payload
                      status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x02);
                      CE_HIGH();
                      CE_LOW();
                      //READ STATUS
                      status = SPI_Send_command_without_ADDR(NOP, NOP);
                      if ((status & MAX_RT) != 0)
                      {
                        var=status;
                        var |= MAX_RT;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_DS) != 0)
                      {
                        var=status;
                        var |= TX_DS;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_FULL) != 0)  //if TX full
                      {
                        status_temp = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);
                      }
                    }
                    
                      if (payload == 0x03)
                    {
                      payload=0;
                     
                      //WRITE CONFIG_REG
                      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0A);  //00001010 - CRC enable, power-up, TX
                      //read CONFIG_REGG
                      config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
                      Delay_(RX_TX_TIME);    //wait while the master go to RX mode
              
                      //Send payload
                      status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x03);
                      CE_HIGH();
                      CE_LOW();
                      //READ STATUS
                      status = SPI_Send_command_without_ADDR(NOP, NOP);
                      if ((status & MAX_RT) != 0)
                      {
                        var=status;
                        var |= MAX_RT;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_DS) != 0)
                      {
                        var=status;
                        var |= TX_DS;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_FULL) != 0)  //if TX full
                      {
                        status_temp = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);
                      }
                    }
                    
                      if (payload == 0x04)
                    {
                      payload=0;
                     
                      //WRITE CONFIG_REG
                      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0A);  //00001010 - CRC enable, power-up, TX
                      //read CONFIG_REGG
                      config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
                      Delay_(RX_TX_TIME);    //wait while the master go to RX mode
              
                      //Send payload
                      status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x04);
                      CE_HIGH();
                      CE_LOW();
                      //READ STATUS
                      status = SPI_Send_command_without_ADDR(NOP, NOP);
                      if ((status & MAX_RT) != 0)
                      {
                        var=status;
                        var |= MAX_RT;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_DS) != 0)
                      {
                        var=status;
                        var |= TX_DS;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_FULL) != 0)  //if TX full
                      {
                        status_temp = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);
                      }
                      
                    }
                    
                      if (payload == 0x05)
                    {
                      payload=0;
                     
                      //WRITE CONFIG_REG
                      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0A);  //00001010 - CRC enable, power-up, TX
                      //read CONFIG_REGG
                      config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
                      Delay_(RX_TX_TIME);    //wait while the master go to RX mode
              
                      //Send payload
                      status = SPI_Send_command_without_ADDR(W_TX_PAYLOAD, 0x05);
                      CE_HIGH();
                      CE_LOW();
                      //READ STATUS
                      status = SPI_Send_command_without_ADDR(NOP, NOP);
                      if ((status & MAX_RT) != 0)
                      {
                        var=status;
                        var |= MAX_RT;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_DS) != 0)
                      {
                        var=status;
                        var |= TX_DS;
                        status_temp = SPI_Send_command_with_ADDR(W_REGISTER, STATUS_ADDR, var);
                      }
                      if ((status & TX_FULL) != 0)  //if TX full
                      {
                        status_temp = SPI_Send_command_without_ADDR(FLUSH_TX, NOP);
                      }
                    }    
                      //WRITE CONFIG_REG
                      status = SPI_Send_command_with_ADDR(W_REGISTER,CONFIG_REG_ADDR, 0x0B);  //00001010 - CRC enable, power-up, RX
                      //read CONFIG_REGG
                      config = SPI_Send_command_with_ADDR(R_REGISTER,CONFIG_REG_ADDR, NOP);
              
              }
          }
      }
    
  }

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/
